//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ړTCYRg[֌WTv
//  `pړTCYRg[̊{NX
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0920 ` 
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plBaseDragResize;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Menus, ExtCtrls,
  Forms, GDIPOBJ, GDIPAPI;

const
  WM_CREATED_RESIZECONTROL = WM_APP+10;
type
  TplBaseDragResize = class;

  TplBaseRubberBand = class(TShape)
  protected
    procedure CMHitTest(var Message: TCMHitTest); message CM_HITTEST;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TplBaseGrabHandle = class(TShape)
  protected
    FResizeBase : TplBaseDragResize;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure CMHitTest(var Message: TCMHitTest); message CM_HITTEST;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TplBaseDragResize = class(TGraphicControl)
  private
    FGrabPoints     : array [0..7] of TPoint;
    FGrabHandle     : array [0..7] of TShape;
    FRubberBand     : TplBaseRubberBand;
    FGrabHandleSize : Integer;
    FGrabBrushColor : TColor;
    FGrabCornerOnly : Boolean;
    FGrabHorzOnly   : Boolean;
    FGrabVertOnly   : Boolean;
    FGrabIndex      : Integer;
    FOperateMouse   : Boolean;
    FIsInSelfRect   : Boolean;
    FCurrentX       : Integer;
    FCurrentY       : Integer;
    FDrawRect       : TRect;
    FDrawLeft       : Integer;
    FDrawTop        : Integer;
    FDrawRight      : Integer;
    FDrawBottom     : Integer;
    FDrawWidth      : Integer;
    FDrawHeight     : Integer;
    FInverseHolz    : Boolean;
    FInverseVert    : Boolean;
    FSelected       : Boolean;
    FMousethrough   : Boolean;
    FMoveOnly       : Boolean;
    FDispOnly       : Boolean;
    FInverseDisp    : Boolean;
    FZoomValue      : Integer;
    FExitMouseEvent : Boolean;
    FAntiAliasing   : Boolean;
    FEnabledUseMsg  : Boolean;
    FParentIsScrBox : Boolean;
    FParentAutoScr  : Boolean;
    procedure SetFSelected(const Value: Boolean);
    procedure SetFMoveOnly(const Value: Boolean);
    procedure SetFAntiAliasing(const Value: Boolean);
    procedure SetFZoomValue(const Value: Integer);
    procedure SetFDispOnly(const Value: Boolean);
    procedure SetFGrabBrushColor(const Value: TColor);
    procedure SetFGrabHandleSize(const Value: Integer);
    procedure SetFGrabCornerOnly(const Value: Boolean);
    procedure SetFGrabHorzOnly(const Value: Boolean);
    procedure SetFGrabVertOnly(const Value: Boolean);
    procedure SetFExitMouseEvent(const Value: Boolean);
  protected
    procedure Paint; override;
    procedure RectToGrabHandlePoints(ARect: TRect);
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure SetParent(AParent: TWinControl); override;
    procedure DoContextPopup(MousePos: TPoint; var Handled: Boolean); override;
    procedure CMHitTest(var Message: TCMHitTest); message CM_HITTEST;
    procedure SetRubberBandGrabHandlePosSize;
    procedure CMVisiblechanged(var Message: TMessage);
      message CM_VISIBLECHANGED;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk);
      message WM_LBUTTONDBLCLK;
    property ZoomValue : Integer read FZoomValue write SetFZoomValue;
    property ExitMouseEvent : Boolean read FExitMouseEvent write SetFExitMouseEvent;
  public
    constructor Create(AOwner: TComponent); override;
    procedure BringToFront(AControl: TGraphicControl = nil);
    procedure SendToBack(AControl: TGraphicControl = nil);
    procedure SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer;
      AHeight: Integer); override;
    procedure ResetInverseDisp;
    procedure DrawRoutine(ACanvas: TCanvas; AGPBitmap: TGPBitmap = nil;
      AOffsetX: Integer = 0; AOffsetY: Integer = 0); virtual;
    property OnDblClick;
    property PopupMenu;
    property RubberBand     : TplBaseRubberBand read FRubberBand;
    property GrabBrushColor : TColor  read FGrabBrushColor write SetFGrabBrushColor;
    property GrabHandleSize : Integer read FGrabHandleSize write SetFGrabHandleSize;
    property GrabCornerOnly : Boolean read FGrabCornerOnly write SetFGrabCornerOnly;
    property GrabHorzOnly   : Boolean read FGrabHorzOnly   write SetFGrabHorzOnly;
    property GrabVertOnly   : Boolean read FGrabVertOnly   write SetFGrabVertOnly;
    property DrawRect     : TRect   read FDrawRect;
    property DrawLeft     : Integer read FDrawLeft;
    property DrawTop      : Integer read FDrawTop;
    property DrawRight    : Integer read FDrawRight;
    property DrawBottom   : Integer read FDrawBottom;
    property DrawWidth    : Integer read FDrawWidth;
    property DrawHeight   : Integer read FDrawHeight;
    property Selected     : Boolean read FSelected     write SetFSelected;
    property MoveOnly     : Boolean read FMoveOnly     write SetFMoveOnly;
    property DispOnly     : Boolean read FDispOnly     write SetFDispOnly;
    property InverseDisp  : Boolean read FInverseDisp  write FInverseDisp;
    property Mousethrough : Boolean read FMousethrough write FMousethrough;
    property AntiAliasing : Boolean read FAntiAliasing write SetFAntiAliasing;
  end;

implementation

uses
  Types,
  Math;

{ TplBaseDragResize }

type
  TScrollCtrl = class(TScrollBox);

//=============================================================================
//  RXgN^
//=============================================================================
constructor TplBaseDragResize.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  ParentColor := False;
  Canvas.Brush.Style := bsClear;

  Width  := 100;
  Height := 100;

  FOperateMouse := False;

  FEnabledUseMsg  := False;
  FSelected       := False;
  FMousethrough   := False;
  FMoveOnly       := False;
  FDispOnly       := False;
  FInverseDisp    := False;
  FAntiAliasing   := True;
  FParentIsScrBox := False;
  FExitMouseEvent := False;
  FZoomValue      := 100;

  FGrabHandleSize := 8;
  FGrabBrushColor := clWhite;
  FGrabCornerOnly := False;
  FGrabHorzOnly   := False;
  FGrabVertOnly   := False;
  FGrabIndex      := -1;
  FIsInSelfRect   := False;

  FInverseHolz := False;
  FInverseVert := False;

  Self.Cursor := crSizeAll;
end;

//=============================================================================
//  SetParent\bh
//=============================================================================
procedure TplBaseDragResize.SetParent(AParent: TWinControl);
var
  LGrabNo : Integer;
  LShape  : TplBaseGrabHandle;
begin
  inherited;

  if not Assigned(AParent) then exit;
  if Assigned(FRubberBand) then exit;

  //o[oh
  FRubberBand := TplBaseRubberBand.Create(Self);
  FRubberBand.Parent      := Parent;
  FRubberBand.Brush.Style := bsClear;
  FRubberBand.Pen.Width   := 1;
  FRubberBand.Pen.Style   := psDot;
  FRubberBand.Visible     := False;

  //Ounh̐
  //eOunh̃}EXJ[\̐ݒ
  for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
    LShape         := TplBaseGrabHandle.Create(Self);
    LShape.Parent  := Parent;
    LShape.Width   := FGrabHandleSize;
    LShape.Height  := FGrabHandleSize;
    LShape.Visible := False;

    if (LGrabNo = 0) or (LGrabNo = 4) then begin
      LShape.Cursor := crSizeNWSE;
    end else
    if (LGrabNo = 2) or (LGrabNo = 6) then begin
      LShape.Cursor := crSizeNESW;
    end else
    if (LGrabNo = 1) or (LGrabNo = 5) then begin
      LShape.Cursor := crSizeNS;
    end else
    if (LGrabNo = 3)or (LGrabNo = 7)then begin
      LShape.Cursor := crSizeWE;
    end;
    FGrabHandle[LGrabNo] := LShape;
  end;

  FParentIsScrBox := Parent is TScrollBox;
  if FParentIsScrBox then begin
    FParentAutoScr := TScrollCtrl(Parent).AutoScroll;
  end;

  //`Rg[gp\ɂȂƂeɒʒm
  if not FEnabledUseMsg then begin
    FEnabledUseMsg := True;
    PostMessage(Parent.Handle, WM_CREATED_RESIZECONTROL, WPARAM(Self), 0);
  end;
end;

//-----------------------------------------------------------------------------
//  CMVisiblechangedbZ[W
//  VislblevpeBύXꂽɔ郁\bh[
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.CMVisiblechanged(var Message: TMessage);
begin
  inherited;
  //o[ohƃOunh̕\E\ύX
  SetRubberBandGrabHandlePosSize;
end;

//-----------------------------------------------------------------------------
//  GrabBrushColorvpeB̐ݒp\bh
//  Ounh̋`̓hׂ̐FύX
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFGrabBrushColor(const Value: TColor);
var
  LGrabNo : Integer;
begin
  if not Assigned(FRubberBand) then exit;

  if FGrabBrushColor <> Value then begin
    FGrabBrushColor := Value;
    for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
      FGrabHandle[LGrabNo].Brush.Color := FGrabBrushColor;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  GrabHandleSizevpeB̐ݒp\bh
//  Ounh̃TCY̐ݒ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFGrabHandleSize(const Value: Integer);
var
  LGrabNo : Integer;
begin
  if not Assigned(FRubberBand) then exit;

  if FGrabHandleSize <> Value then begin
    FGrabHandleSize := Value;
    for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
      FGrabHandle[LGrabNo].Width  := FGrabHandleSize;
      FGrabHandle[LGrabNo].Height := FGrabHandleSize;
    end;
  end;
end;

//=============================================================================
//  DoContextPopup\bh
//  IԂłȂ̓|bvAbvj[\Ȃ
//=============================================================================
procedure TplBaseDragResize.DoContextPopup(MousePos: TPoint;
  var Handled: Boolean);
var
  LPos : TPoint;
begin
  inherited;
  if not Assigned(PopupMenu) then exit;

  PopupMenu.AutoPopup := False;
  if FSelected then begin
    LPos := ClientToScreen(MousePos);
    PopupMenu.Popup(LPos.X, LPos.Y);
  end else begin
    Handled := True;
  end;
end;

//-----------------------------------------------------------------------------
//  SelectedvpeB̐ݒ胁\bh
//  IEĨvpeB
//  Trueɂƃo[ohƃOunh\
//  FalseɂƂ\ɂ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFSelected(const Value: Boolean);
begin
  if FSelected <> Value then begin
    FSelected := Value;
    if (FSelected = False) or FDispOnly then begin
      FGrabIndex    := -1;
      FIsInSelfRect := False;
    end;
    SetRubberBandGrabHandlePosSize;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  MoveOnlyvpeB̐ݒp\bh
//  TrueɂƃOunh\Ȃ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFMoveOnly(const Value: Boolean);
var
  LGrabNo : Integer;
begin
  if FMoveOnly <> Value then begin
    FMoveOnly := Value;
    for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
      FGrabHandle[LGrabNo].Visible := not FMoveOnly;
    end;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  DispOnlyvpeB̐ݒp\bh
//  TrueɂƑIłȂȂ\pƂȂ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFDispOnly(const Value: Boolean);
begin
  if FDispOnly <> Value then begin
    FDispOnly := Value;
    if FDispOnly then begin
      SetFSelected(False);
      Self.Cursor := crDefault;
    end else begin
      Self.Cursor := crSizeAll;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  GrabCornerOnlyvpeB̐ݒp\bh
//  4̃Ounh\
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFGrabCornerOnly(const Value: Boolean);
begin
  if FGrabCornerOnly <> Value then begin
    FGrabCornerOnly := Value;

    FGrabHorzOnly := False;
    FGrabVertOnly := False;
    SetRubberBandGrabHandlePosSize;
  end;
end;

//-----------------------------------------------------------------------------
//  GrabHorzOnlyvpeB̐ݒp\bh
//  TCYp̍E2\
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFGrabHorzOnly(const Value: Boolean);
begin
  if FGrabHorzOnly <> Value then begin
    FGrabHorzOnly := Value;

    FGrabCornerOnly := False;
    FGrabVertOnly   := False;
    SetRubberBandGrabHandlePosSize;
  end;
end;

//-----------------------------------------------------------------------------
//  GrabVertOnlyvpeB̐ݒp\bh
//  TCYp̏㉺2\
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFGrabVertOnly(const Value: Boolean);
begin
  if FGrabVertOnly <> Value then begin
    FGrabVertOnly := Value;

    FGrabCornerOnly := False;
    FGrabHorzOnly   := False;
    SetRubberBandGrabHandlePosSize;
  end;
end;

//-----------------------------------------------------------------------------
//  AntiAliasingvpeB̐ݒp\bh
//  A`GCAVO̐ݒ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFAntiAliasing(const Value: Boolean);
begin
  if FAntiAliasing <> Value then begin
    FAntiAliasing := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  ExitMouseEventvpeB̐ݒp\bh
//  pNXł̃}EXCxg̎p
//  ReiRg[̐ݒp
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFExitMouseEvent(const Value: Boolean);
begin
  if FExitMouseEvent <> Value then begin
    FExitMouseEvent := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  ZoomValuevpeB̐ݒp\bh
//  gEk\̒l̐ݒ
//  {`Rg[ɂ͎ۂ̊gEk\̋@\͂Ȃ
//  ReipRg[̑p
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetFZoomValue(const Value: Integer);
begin
  if FZoomValue <> Value then begin
    FZoomValue := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  őOʂɈړ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.BringToFront(AControl: TGraphicControl);
var
  LGrabNo : Integer;
begin
  TControl(Self).BringToFront;
  if AControl <> nil then begin
    AControl.BringToFront;
  end;
  FRubberBand.BringToFront;
  for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
    FGrabHandle[LGrabNo].BringToFront;
    Application.ProcessMessages;
  end;
end;

//-----------------------------------------------------------------------------
//  ŔwʂɈړ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SendToBack(AControl: TGraphicControl = nil);
var
  LGrabNo : Integer;
begin
  for LGrabNo := Length(FGrabHandle) - 1 downto 0 do begin
    FGrabHandle[LGrabNo].SendToBack;
    Application.ProcessMessages;
  end;
  if AControl <> nil then begin
    AControl.SendToBack;
  end;
  FRubberBand.SendToBack;
  TControl(Self).SendToBack;
end;

//=============================================================================
//  MouseDown\bh
//  IԂ̎́C}EX{^őIԂɂĈړTCY\ɂ
//  IԂɂƂƂ́Co[ohƃOunh\邱
//
//  [Ctrl]L[ĂȂ΁CɑI𒆂̂̃NX̃Rg[
//  IԂɂ(o[ohƃOunh\ɂ)
//=============================================================================
procedure TplBaseDragResize.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  LPosInParent : TPoint;
  LSelfRect    : TRect;
  LClipRect    : TRect;
  LControl     : TControl;
  LControlNo   : Integer;
  LParentForm  : TCustomForm;
begin
  inherited;
  if FDispOnly then exit;
  if FExitMouseEvent then exit;
  if Button <> mbLeft then exit;


  FOperateMouse := True;

  //L[ɂ鑀\ɂ
  //etH[ô̕@͊ȕ֖@
  LParentForm := GetParentForm(Self);
  if LParentForm <> nil then begin
    LParentForm.ActiveControl := Parent;
  end;

  FOperateMouse := True;

  //-1̎̓OunhIĂȂ
  FGrabIndex := -1;
  //}EXJ[\Ounhɂ邩
  if not FMoveOnly then begin
    for LControlNo := 0 to Length(FGrabPoints) - 1 do begin
      if FGrabHandle[LControlNo].Visible then begin
        if PtInRect(Bounds(FGrabPoints[LControlNo].X - 1,
                           FGrabPoints[LControlNo].Y - 1,
                           (FGrabHandleSize + 1) * 2,
                           (FGrabHandleSize + 1) * 2),
                           Point(X, Y)) then begin
          FCurrentX  := X;
          FCurrentY  := Y;
          FGrabIndex := LControlNo;
          Break;
        end;
      end;
    end;
  end;

  //}EXJ[\OunhłȂΖ{Rg[𒲍
  LPosInParent := Self.ClientToParent(Point(X, Y));
  if FGrabIndex = -1 then begin
    LSelfRect := Bounds(Left, Top, Width, Height);
    FIsInSelfRect := PtInRect(LSelfRect, LPosInParent);
    if FIsInSelfRect then begin
      FCurrentX := LPosInParent.X;
      FCurrentY := LPosInParent.Y;
    end;
  end;

  FSelected := ((FGrabIndex >= 0) or FIsInSelfRect) and not FDispOnly;
  if FSelected then begin
    //[Ctrl]͕I\Ƃ̂őI͉Ȃ
    //I̓}EX߂Ƃړ͐eRg[̃}EXCxgōs
    if (ssCtrl in Shift) then begin
      for LControlNo := 0 to Parent.ControlCount - 1 do begin
        LControl := Parent.Controls[LControlNo];
        if LControl Is TplBaseDragResize then begin
          if (LControl <> Self) then begin
            //1łɑIԂ̃Rg[ꍇ
            if TplBaseDragResize(LControl).Selected then begin
              TplBaseDragResize(LControl).Mousethrough := True;
              FMousethrough := True;
              break;
            end;
          end;
        end;
      end;
    end else begin
      //gȊȎI
      //IԂɂȂ}EẌړ͈͂̐eRg[Ƃ
      for LControlNo := 0 to Parent.ControlCount - 1 do begin
        LControl := Parent.Controls[LControlNo];
        if LControl Is TplBaseDragResize then begin
          TplBaseDragResize(LControl).Mousethrough := False;
          if (LControl <> Self) then begin
            TplBaseDragResize(LControl).SetFSelected(False);
          end;
        end;
      end;
      Invalidate;

      LClipRect := Parent.ClientRect;
      LClipRect.TopLeft     := Parent.ClientToScreen(LClipRect.TopLeft);
      LClipRect.BottomRight := Parent.ClientToScreen(LClipRect.BottomRight);
      ClipCursor(@LClipRect);
    end;
  end;
end;

//=============================================================================
//  MouseMove\bh
//=============================================================================
procedure TplBaseDragResize.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  LPosInParent  : TPoint;
  LLeft         : Integer;
  LTop          : Integer;
  LWidth        : Integer;
  LHeight       : Integer;
  LIncX         : Integer;
  LIncY         : Integer;
  LHorzScrPos   : Integer;
  LVertScrPos   : Integer;
  LHorzScrRange : Integer;
  LVertScrRange : Integer;
  LPixelSize    : Integer;
begin
  inherited;

  LPixelSize := ZoomValue div 100;

  if FExitMouseEvent then exit;
  if FDispOnly then exit;


  //}EXJ[\̓OunhɂȂ
  if FGrabIndex = -1 then begin

    //IuWFNg̋`ɂꍇ
    if FIsInSelfRect then begin
      LPosInParent := ClientToParent(Point(X, Y));

      LIncX := LPosInParent.X - FCurrentX;
      LIncY := LPosInParent.Y - FCurrentY;

      //eTScrollBox̎̏
      //ŉ[ւ̈ړƍŉE[獶Ɉړꍇ
      //̏ȂƈړłȂ
      if FParentIsScrBox and FSelected then begin
        LHorzScrPos   := TScrollCtrl(Parent).HorzScrollBar.Position;
        LVertScrPos   := TScrollCtrl(Parent).VertScrollBar.Position;
        LHorzScrRange := TScrollCtrl(Parent).HorzScrollBar.Range;
        LVertScrRange := TScrollCtrl(Parent).VertScrollBar.Range;


        if (LIncY < 0) and (LVertScrPos > 0) then begin
          if ((Top + Height+ FGrabHandleSize) >= Parent.ClientHeight) then begin
            TScrollCtrl(Parent).VertScrollBar.Range := LVertScrRange - LIncY;
          end;
          if (Top <= 0) then begin
            TScrollCtrl(Parent).VertScrollBar.Position := LVertScrPos + LIncY;
          end;
        end;
        if (LIncX <= 0) and (LHorzScrPos > 0) then begin
          if ((Left + Width + FGrabHandleSize) >= Parent.ClientWidth) then begin
            TScrollCtrl(Parent).HorzScrollBar.Range := LHorzScrRange - LIncX;
          end;
          if (Left <= 0) then begin
            TScrollCtrl(Parent).HorzScrollBar.Position := LHorzScrPos + LIncX;
          end;
        end;
      end;

      LLeft := (Left + LIncX + Width)  div LPixelSize * LPixelSize;
      LTop  := (Top  + LIncY + Height) div LPixelSize * LPixelSize;

      SetBounds(LLeft - Width, LTop - Height, Width, Height);

      FCurrentX := LPosInParent.X div LPixelSize * LPixelSize;
      FCurrentY := LPosInParent.Y div LPixelSize * LPixelSize;
    end else begin
      exit;
    end;
  end else begin
    //}EXJ[\Ounhɂꍇ
    LLeft   := Left;
    LTop    := Top;
    LWidth  := Width;
    LHeight := Height;

    case FGrabIndex of
      0:
      begin
        LLeft := Left + (X - FCurrentX);
        LTop  := Top  + (Y - FCurrentY);
       end;
      1:
      begin
        LTop := Top + (Y - FCurrentY);
      end;
      2:
      begin
        LWidth := Width + (X - FCurrentX);
        LTop   := Top + (Y - FCurrentY);
      end;
      3:
      begin
        LWidth := Width + (X - FCurrentX);
      end;
      4:
      begin
        LWidth  := Width  + (X - FCurrentX);
        LHeight := Height + (Y - FCurrentY);
      end;
      5:
      begin
        LHeight := Height + (Y - FCurrentY);
      end;
      6:
      begin
        LLeft   := left + (X - FCurrentX);
        LHeight := Height + (Y - FCurrentY);
      end;
      7:
      begin
        LLeft := Left + (X - FCurrentX);
      end;
    end;

    LLeft   := LLeft div LPixelSize * LPixelSize;
    LTop    := LTop  div LPixelSize * LPixelSize;

    LWidth  := (LWidth + (Left - LLeft)) div LPixelSize * LPixelSize;
    LHeight := (LHeight + (Top - LTop)) div LPixelSize * LPixelSize;

    SetBounds(LLeft, LTop, LWidth, LHeight);

    FCurrentX := X div LPixelSize * LPixelSize;
    FCurrentY := Y div LPixelSize * LPixelSize;
  end;
end;

//=============================================================================
//  MouseUp\bh
//
//  ȉ̏
//  }EXJ[\ړ͈͂̐
//  Ounh͂ǂ͂łȂƂɂ
//  IuWFNg̋`͂łȂƂɂ
//=============================================================================
procedure TplBaseDragResize.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  LLeft       : Integer;
  LTop        : Integer;
  LWidth      : Integer;
  LHeight     : Integer;
  LPixelSize  : Integer;
  LHorzRange  : Integer;
  LVertRange  : Integer;
  LControlNo  : Integer;
  LControl    : TControl;
  LCtrl       : TplBaseDragResize;
  LHorzScrPos : Integer;
  LVertScrPos : Integer;
begin
  inherited;
  if FExitMouseEvent then exit;
  if FDispOnly then exit;


  LPixelSize := FZoomValue div 100;
  if LPixelSize = 0 then LPixelSize := 1;

  //}EXJ[\̓OunhɂȂ
  if FGrabIndex = -1 then begin
    //IuWFNg̋`ɂꍇ
    if FIsInSelfRect then begin
      LLeft := Left div LPixelSize * LPixelSize;
      LTop  := Top  div LPixelSize * LPixelSize;
      SetBounds(LLeft, LTop, Width, Height);
    end;

    //eTScrollBox̃TCY𒲐
    //ŉ[ւ̈ړƍŉE[獶ɈړꍇɕKv
    if FParentIsScrBox then begin
      LHorzScrPos := TScrollCtrl(Parent).HorzScrollBar.Position;
      LVertScrPos := TScrollCtrl(Parent).VertScrollBar.Position;

      if (LHorzScrPos > 0) or (LVertScrPos > 0) then begin
        LHorzRange := 0;
        LVertRange := 0;
        for LControlNo := 0 to Parent.ControlCount - 1 do begin
          LControl := Parent.Controls[LControlNo];
          if LControl Is TplBaseDragResize then begin
            LCtrl := TplBaseDragResize(LControl);
            LHorzRange := Max(LHorzRange, LHorzScrPos + LCtrl.Left + LCtrl.Width);
            LVertRange := Max(LVertRange, LVertScrPos + LCtrl.Top + LCtrl.Height);
          end;
        end;
        TScrollCtrl(Parent).HorzScrollBar.Range := LHorzRange;
        TScrollCtrl(Parent).VertScrollBar.Range := LVertRange;
      end;
      if FParentIsScrBox then begin
        TScrollCtrl(Parent).AutoScroll := FParentAutoScr;
      end;
    end;
  end else begin
    //}EXJ[\Ounhɂꍇ

    LWidth  := Width;
    LHeight := Height;
    LLeft   := Left div LPixelSize * LPixelSize;
    LTop    := Top  div LPixelSize * LPixelSize;

    if LLeft < Left then begin
      LWidth := LWidth + (Left - LLeft);
    end;
    if LTop < Top then begin
      LHeight := LHeight + (Top - LTop);
    end;

    //⍂0ɂĂ܂ƃ}EXőIłȂȂ̂ł̑΍
    LWidth  := Max(LPixelSize, LWidth  div LPixelSize * LPixelSize);
    LHeight := Max(LPixelSize, LHeight div LPixelSize * LPixelSize);
    SetBounds(LLeft, LTop, LWidth, LHeight);
  end;

  //Y[TScrollBox֌W̏ȂΈȉ̃R[hł悢
  ClipCursor(nil);
  FGrabIndex    := -1;
  FIsInSelfRect := False;

  FOperateMouse := False;
end;

//=============================================================================
//  WM_LBUTTONDBLCLKbZ[W
//  OOnDblclickCxg`Ďgpꍇ̑Ή
//  }EX{^UPƓĕ`Rg[͂łȂԂɂ
//=============================================================================
procedure TplBaseDragResize.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  inherited;
  if FExitMouseEvent then exit;

  if Assigned(OnDblClick) then begin
    ClipCursor(nil);
    FGrabIndex    := -1;
    FIsInSelfRect := False;

    FOperateMouse := False;
  end;
end;

//=============================================================================
//  CM_HITTESTbZ[W
//  FMousethrough̓}EX߂̃vpeB
//=============================================================================
procedure TplBaseDragResize.CMHitTest(var Message: TCMHitTest);
begin
  if (FMousethrough) or (FExitMouseEvent) then begin
    Message.Result := HTNOWHERE;
  end else begin
    inherited;
  end;
end;

//=============================================================================
//  `Rg[(g)̈ʒuCTCYύXɂȂꍇ
//  o[ohƃOunhĕ`
//=============================================================================
procedure TplBaseDragResize.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited;
  if not Assigned(Parent) then exit;

  if (Top < Parent.ClientHeight) or ((Top + Height) > 0)
    or ((Left + Width) < 0) or (Left > Parent.ClientWidth) then begin
    SetRubberBandGrabHandlePosSize;
  end;

  if not FOperateMouse then begin
    if (AWidth <= 0) or (AHeight <= 0) then begin
      AWidth  := Max(AWidth, 1);
      AHeight := Max(AHeight, 1);
      SetBounds(ALeft, ATop, AWidth, AHeight);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  o[ohƃOunhwTCYƈʒuɕ`
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.SetRubberBandGrabHandlePosSize;
var
  LGrabNo : Integer;
begin
  if not FSelected then begin
    FRubberBand.Visible := False;
    for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
      FGrabHandle[LGrabNo].Visible := False;
    end;
    exit;
  end;

  //o[oh
  FRubberBand.SetBounds(Left, Top, Width, Height);
  FRubberBand.Visible := Visible and not FDispOnly;

  //Ounh
  if not FMoveOnly then begin
    RectToGrabHandlePoints(Bounds(Left, Top, Width, Height));
    for LGrabNo := 0 to Length(FGrabHandle) - 1 do begin
      FGrabHandle[LGrabNo].Left    := FGrabPoints[LGrabNo].X;
      FGrabHandle[LGrabNo].Top     := FGrabPoints[LGrabNo].Y;
      FGrabHandle[LGrabNo].Visible := Visible and not FDispOnly;
    end;

    if Visible and not FDispOnly then begin
      if FGrabCornerOnly then begin
        FGrabHandle[1].Visible := False;
        FGrabHandle[3].Visible := False;
        FGrabHandle[5].Visible := False;
        FGrabHandle[7].Visible := False;
      end else
      if FGrabHorzOnly then begin
        FGrabHandle[0].Visible := False;
        FGrabHandle[1].Visible := False;
        FGrabHandle[2].Visible := False;
        FGrabHandle[4].Visible := False;
        FGrabHandle[5].Visible := False;
        FGrabHandle[6].Visible := False;

        FGrabHandle[3].Invalidate;
        FGrabHandle[7].Invalidate;
      end else
      if FGrabVertOnly then begin
        FGrabHandle[0].Visible := False;
        FGrabHandle[2].Visible := False;
        FGrabHandle[3].Visible := False;
        FGrabHandle[4].Visible := False;
        FGrabHandle[6].Visible := False;
        FGrabHandle[7].Visible := False;

        FGrabHandle[1].Invalidate;
        FGrabHandle[5].Invalidate;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  Ounh̕\WvZ
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.RectToGrabHandlePoints(ARect: TRect);
var
  LHalfW : Integer;
  LLeft  : Integer;
  LTop   : Integer;
begin
  LHalfW := FGrabHandleSize div 2;
  LLeft  := ARect.Left + (ARect.Right - ARect.Left) div 2;
  LTop   := ARect.Top + (ARect.Bottom - ARect.Top) div 2;

  FGrabPoints[0] := Point(ARect.Left - LHalfW,  ARect.Top - LHalfW);
  FGrabPoints[1] := Point(LLeft - LHalfW,       ARect.Top - LHalfW);
  FGrabPoints[2] := Point(ARect.Right - LHalfW, ARect.Top - LHalfW);
  FGrabPoints[3] := Point(ARect.Right - LHalfW, LTop - LHalfW);
  FGrabPoints[4] := Point(ARect.Right - LHalfW, ARect.Bottom - LHalfW);
  FGrabPoints[5] := Point(LLeft - LHalfW,       ARect.Bottom - LHalfW);
  FGrabPoints[6] := Point(ARect.Left - LHalfW,  ARect.Bottom - LHalfW);
  FGrabPoints[7] := Point(ARect.Left - LHalfW,  LTop - LHalfW);
end;

//=============================================================================
//  Paint\bh
//  ۂ̕`揈͌pNXDrawRoutine\bhōs
//=============================================================================
procedure TplBaseDragResize.Paint;
begin
  inherited;
  if not Assigned(Parent) then exit;

  //⍂ɂȂꍇ̏
  if Width < 0 then begin
    FInverseHolz := not FInverseHolz;
    Width := Abs(Width);
    Left  := Left - Width;
    if FSelected then begin
      case FGrabIndex of
        0: FGrabIndex := 2;
        7: FGrabIndex := 3;
        6: FGrabIndex := 4;
        2: FGrabIndex := 0;
        3: FGrabIndex := 7;
        4: FGrabIndex := 6;
      end;
    end;
  end;
  if Height < 0 then begin
    FInverseVert := not FInverseVert;
    Height := Abs(Height);
    Top    := Top - Abs(Height);
    if FSelected then begin
      case FGrabIndex of
        0: FGrabIndex := 6;
        1: FGrabIndex := 5;
        2: FGrabIndex := 4;
        4: FGrabIndex := 2;
        5: FGrabIndex := 1;
        6: FGrabIndex := 0;
      end;
    end;
  end;


  //o[ohƃOunh̕`
  SetRubberBandGrabHandlePosSize;

  //`惋[`̎s
  DrawRoutine(Canvas);
end;

//-----------------------------------------------------------------------------
//  ۂ̕`p̏
//  ACanvasɂ̃\bh̕`R[hs
//  ۂ̕`R[h͔hNXɌp\bhčs
//
//  `Jnʒu͏(FDrawLeft, FDrawTop)
//  ]`悪svȂ Rect(0, 0, Widht, Heidht) ̕`ł悢
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.DrawRoutine(ACanvas: TCanvas; AGPBitmap: TGPBitmap;
  AOffsetX: Integer; AOffsetY: Integer);
begin
  if (ACanvas = nil) and (AGPBitmap = nil) then exit;

  //㉺E]̎
  if FInverseDisp and FInverseHolz and FInverseVert then begin
    //EXWl(Left,Right)
    //㉺YWl(Top,Bottom)
    FDrawLeft   := ClientRect.Right + AOffsetX;
    FDrawTop    := ClientRect.Bottom + AOffsetY;
    FDrawRight  := ClientRect.Left + AOffsetX;
    FDrawBottom := ClientRect.Top + AOffsetY;
    FDrawWidth  := -Width;
    FDrawHeight := -Height;
  end else
  //E]̎
  if FInverseDisp and FInverseHolz then begin
    //EXWl(Left,Right)
    FDrawLeft   := ClientRect.Right + AOffsetX;
    FDrawTop    := ClientRect.Top + AOffsetY;
    FDrawRight  := ClientRect.Left + AOffsetX;
    FDrawBottom := ClientRect.Bottom + AOffsetY;
    FDrawWidth  := -Width;
    FDrawHeight := Height;
  end else
  //㉺]̎
  if FInverseDisp and FInverseVert then begin
    //㉺YWl(Top,Bottom)
    FDrawLeft   := ClientRect.Left + AOffsetX;
    FDrawTop    := ClientRect.Bottom + AOffsetY;
    FDrawRight  := ClientRect.Right + AOffsetX;
    FDrawBottom := ClientRect.Top + AOffsetY;
    FDrawWidth  := Width;
    FDrawHeight := -Height;
  end else begin
    FDrawLeft   := ClientRect.Left + AOffsetX;
    FDrawTop    := ClientRect.Top + AOffsetY;
    FDrawRight  := ClientRect.Right + AOffsetX;
    FDrawBottom := ClientRect.Bottom + AOffsetY;
    FDrawWidth  := Width;
    FDrawHeight := Height;
  end;
  FDrawRect := Bounds(FDrawLeft, FDrawTop, FDrawWidth, FDrawHeight);
end;

//-----------------------------------------------------------------------------
//  FDraw֌W̒lɖ߂
//  ȉ̒lFalseɂΕ`̍ۂɔ]Ԃɖ߂Ƃł
//  OTGPBitmap擾ꍇ]Ԃ̉摜ƂȂ
//  ҏWĂ̕`Rg[ŕ\Ɣ]Ă܂
//  ̑΍p
//-----------------------------------------------------------------------------
procedure TplBaseDragResize.ResetInverseDisp;
begin
  FInverseHolz := False;
  FInverseVert := False;
end;

{ TplBaseGrabHandle }

//=============================================================================
//  OunhNX̃RXgN^
//  {IȐݒ̂
//=============================================================================
constructor TplBaseGrabHandle.Create(AOwner: TComponent);
begin
  inherited;
  FResizeBase := TplBaseDragResize(AOwner);

  Brush.Style := bsSolid;
  Brush.Color := clWhite;
  Pen.Color   := clBlack;
  Pen.Width   := 2;
  Pen.Style   := psSolid;
end;

//=============================================================================
//  CM_HITTESTbZ[W
//  TplBaseDragResize}EXߎ̓Ounh}EXCxg߂Ƃ
//=============================================================================
procedure TplBaseGrabHandle.CMHitTest(var Message: TCMHitTest);
begin
  if(FResizeBase.Mousethrough) or (FResizeBase.FExitMouseEvent) then begin
    Message.Result := HTNOWHERE;
  end else begin
    inherited;
  end;
end;

//=============================================================================
//  MouseDown\bh
// TplBaseDragResizeŏ
//=============================================================================
procedure TplBaseGrabHandle.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  LPos : TPoint;
begin
  inherited;
  if FResizeBase.Selected then begin
    LPos := ClientToParent(Point(X, Y));
    FResizeBase.MouseDown(Button, Shift, LPos.X, LPos.Y);
  end;
end;

//=============================================================================
//  MouseMove\bh
// TplBaseDragResizeŏ
//=============================================================================
procedure TplBaseGrabHandle.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  LPos : TPoint;
begin
  inherited;
  if FResizeBase.Selected then begin
    LPos := ClientToParent(Point(X, Y));
    FResizeBase.MouseMove(Shift, LPos.X, LPos.Y);
  end;
end;

//=============================================================================
//  MouseUp\bh
// TplBaseDragResizeŏ
//=============================================================================
procedure TplBaseGrabHandle.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  LPos : TPoint;
begin
  inherited;
  if FResizeBase.Selected then begin
    LPos := ClientToParent(Point(X, Y));
    FResizeBase.MouseUp(Button, Shift, LPos.X, LPos.Y);
  end;
end;

{ TplBaseRubberBand }

//=============================================================================
//  o[ohNX̃RXgN^
//  {IȐݒ̂
//=============================================================================
constructor TplBaseRubberBand.Create(AOwner: TComponent);
begin
  inherited;

  Brush.Style := bsClear;
  Pen.Color   := clBlack;
  Pen.Width   := 1;
  Pen.Style   := psDot;
end;

//=============================================================================
//  CM_HITTESTbZ[W
//  }EXCxg͑Sē
//  }EXCxg͑STplBaseDragResizeŏ
//=============================================================================
procedure TplBaseRubberBand.CMHitTest(var Message: TCMHitTest);
begin
  Message.Result := HTNOWHERE;
end;

end.
