//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
{$M+}
//=============================================================================
//  ړTCYRg[֌WTv
//  wiƂĎgpReip̃Rg[
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0920 ` 
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plContainerPanel;

interface

uses
  Windows, Messages,SysUtils, Classes, Graphics, Controls, StdCtrls, ExtCtrls,
  Forms, plBaseDragResize, GDIPAPI, GDIPOBJ, GDIPUTIL, Generics.Collections;

type
  TplContainerPanel = class;

  TplCtrlList = class(TList<TplBaseDragResize>)
  private
    function GetFItemIndex: Integer;
    procedure SetFItemIndex(const Value: Integer);
  protected
    procedure Notify(const Item: TplBaseDragResize; Action:
      TCollectionNotification); override;
  published
  public
    procedure Clear;
    function SelCount: Integer;
    property ItemIndex  : Integer read GetFItemIndex write SetFItemIndex;
  end;

  TplContainerPanel = class(TCustomPanel)
  private
    FCtrlList         : TplCtrlList;
    FBackImagePath    : string;
    FBackBitmap       : TBitmap;
    FBackImage        : Boolean;
    FExitMouseEvent   : Boolean;
    FDragFlag         : Boolean;
    FDragStartY       : Integer;
    FDragStartX       : Integer;
    FRubberShape      : TShape;
    FSelectMode       : Boolean;
    FPtInAnyCtrlRect  : Boolean;
    FZoomOriginValue  : Integer;
    FZoomBeforeValue  : Integer;
    FZoomCurrensValue : Integer;
    FZoomValue        : Integer;
    procedure SetBackImage(const Value: Boolean);
    procedure SetFExitMouseEvent(const Value: Boolean);
  protected
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MoveResizeControlByKey(ALeft, ATop, AWidth, AHeight,
      AdecX, AdecY, AdecW, AdecH: Integer);
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer;
      Y: Integer); override;
    procedure DoContextPopup(MousePos: TPoint; var Handled: Boolean); override;
    procedure WMCreatedresizecontrol(var Message: TMessage);
      message WM_CREATED_RESIZECONTROL;
    procedure CMColorchanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function PtInResizeCtrl(X, Y: Integer; ACtrl: TplBaseDragResize): Boolean;
    function GetPtInResizeCtrl(X, Y: Integer): TplBaseDragResize;
    procedure SelectAllCtrls;
    procedure DeSelectAllCtrls;
    procedure DeleteCtrl(AIndex: Integer = -1);
    procedure DeleteAllCtrls;
    procedure BringToFrontCtrl(AIndex: Integer = -1);
    procedure SendToBackCtrl(AIndex: Integer = -1);
    procedure SetZOrderCtrl(ACtrl: TplBaseDragResize; NewIndex: Integer=-1); overload;
    procedure SetZOrderCtrl(OldIndex: Integer; NewIndex: Integer=-1); overload;
    procedure SetZoomValue(AZoomValue: Integer = 100);
    function SelectedCtrlsRect: TRect;
    function LocatedCtrlsRange: TPoint;
    procedure AlignSelectedCtrls(AType: TAlign);
    procedure CascadeSelectedCtrls(ADistance: Integer);
    function GPBitmapFromSelectedCtrls: TGPBitmap;
    procedure BitmapFromSelectedCtrls(ABitmap: TBitmap);
    property ExitMouseEvent : Boolean read FExitMouseEvent write SetFExitMouseEvent;
  published
    property Align;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnKeyDown;
    property PopupMenu;
    property Color;
    property CtrlList   : TplCtrlList read FCtrlList;
    property BackImage  : Boolean read FBackImage   write SetBackImage;
    property SelectMode : Boolean read FSelectMode  write FSelectMode;
    property ZoomValue  : Integer read FZoomValue;
  end;

implementation

uses
  Math,
  plGPResizeLine;

{TplContainerPanel}

type
  TContainerCtrl  = class(TCustomPanel);
  TBaseResizeCtrl = class(TplBaseDragResize);

var
  FSelfBackControl : TplContainerPanel;

//=============================================================================
//  RXgN^
//=============================================================================
constructor TplContainerPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  DoubleBuffered   := True;
  ParentBackground := False;
  //[csOpaque]͕Kvɉ...
  ControlStyle := ControlStyle + [csOpaque];

  FSelfBackControl  := Self;

  FZoomOriginValue  := 100;
  FZoomBeforeValue  := FZoomOriginValue;
  FZoomCurrensValue := FZoomOriginValue;
  FZoomValue        := 100;

  FSelectMode      := False;
  FPtInAnyCtrlRect := False;

  FCtrlList := TplCtrlList.Create;

  BorderStyle := bsNone;
  Color       := clWhite;
  FBackImage  := False;

  FBackBitmap    := TBitmap.Create;
  FBackImagePath := ExpandFileName('backTexture_01.bmp');
  if FileExists(FBackImagePath) then begin
    FBackBitmap.LoadFromFile(FBackImagePath);
  end;
end;

//=============================================================================
//  fRXgN^
//=============================================================================
destructor TplContainerPanel.destroy;
begin
  FreeAndNil(FCtrlList);
  FreeAndNil(FBackBitmap);

  inherited;
end;

//-----------------------------------------------------------------------------
//  `Rg[Parent̐ݒ肪ĨbZ[W
//  `Rg[瑗Ă郁bZ[W
//
//  Ǘp̔zɒǉ
//  g\ɕ`Rg[ǉꍇC̕`Rg[g
//
//  [l]
//  Rg[ołCM_CONTROLCHANGEbZ[Wgp\
//  CM_CONTROLCHANGE͎qRg[̐C폜̍ۂɔ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.WMCreatedresizecontrol(
  var Message: TMessage);
var
  LCtrl : TplBaseDragResize;
begin
  LCtrl := TplBaseDragResize(Message.WParam);
  FCtrlList.Add(LCtrl);
  SetZoomValue(-1);
end;

//=============================================================================
//  Paint\bh
//  wip̉摜`
//=============================================================================
procedure TplContainerPanel.Paint;
var
  LBitmap : TBitmap;
begin
  inherited;

  if (Assigned(FBackBitmap)) and FBackImage then begin
    LBitmap := TBitmap.Create;
    try
      //傫ȃTCYɂȂƃ\[XsɂȂ
      LBitmap.SetSize(Width, Height);
      LBitmap.Canvas.Brush.Bitmap := FBackBitmap;
      LBitmap.Canvas.FillRect(LBitmap.Canvas.ClipRect);
      Canvas.Draw(0, 0, LBitmap);
    finally
      FreeAndNil(LBitmap);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  CM_COLORCHANGEDbZ[W
//  FύXƔwi摜\ɂȂ̂ŃvpeBύXĂ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.CMColorchanged(var Message: TMessage);
begin
  inherited;
  if not Assigned(Parent) then exit;

  FBackImage := False;
  Invalidate;
end;

//-----------------------------------------------------------------------------
//  BackImagevpeB̐ݒp\bh
//  wi摜̕\E\̐؂芷
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SetBackImage(const Value: Boolean);
begin
  if Value <> FBackImage then begin
    FBackImage := Value;
    Invalidate;
  end;
end;

//=============================================================================
//  DoContextPopup\bh
//
//  J[\`Rg[̋`̈ɂ鎞|bvAbvj[\
//  ̃Rg[IԂɂȂĂȂ͖
//
//  [l]
//  ̕`Rg[IԂ̎̓}EXCxgߏԂɂȂĂ
//   FindDragTarget֐ł̓Rg[̌o͂łȂ
//=============================================================================
procedure TplContainerPanel.DoContextPopup(MousePos: TPoint;
  var Handled: Boolean);
var
  LPos    : TPoint;
  LCtrl   : TplBaseDragResize;
  LCtrlNo : Integer;
  LSelCnt : Integer;
  LFlag   : Boolean;
begin
  inherited;
  if not Assigned(PopupMenu) then exit;

  PopupMenu.AutoPopup := False;
  LPos.X := MousePos.X;
  LPos.Y := MousePos.Y;

  LFlag   := False;
  LSelCnt := 0;
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    if LCtrl.Selected then  Inc(LSelCnt);
    if PtInResizeCtrl(LPos.X, LPos.Y, LCtrl) then begin
      LFlag := True;
    end;
  end;

  if LFlag and (LSelCnt >= 2) then begin
    LPos := ClientToScreen(MousePos);
    PopupMenu.Popup(LPos.X, LPos.Y);
  end else begin
    Handled := True;
  end;
end;

//-----------------------------------------------------------------------------
//  w肵CfbNX̕`Rg[폜
//  CfbNXw肵Ȃꍇ͑I𒆂̑SẴRg[폜
//-----------------------------------------------------------------------------
procedure TplContainerPanel.DeleteCtrl(AIndex: Integer);
var
  LCtrlNo  : Integer;
  LCtrl    : TplBaseDragResize;
  LDelFlag : Boolean;
begin
  if FCtrlList.Count <= 0 then exit;

  LDelFlag := False;
  if AIndex >= 0 then begin
    if AIndex < FCtrlList.Count then begin
      FCtrlList.Delete(AIndex);
      LDelFlag := True;
    end;
  end else begin
    for LCtrlNo := FCtrlList.Count - 1 downto 0 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if LCtrl.Selected then begin
        FCtrlList.Delete(LCtrlNo);
        LDelFlag := True;
      end;
    end;
  end;

  //ZI[_ŏʂ̃Rg[IԂɂ
  AIndex := FCtrlList.Count - 1;
  if (AIndex >= 0) and LDelFlag then begin
    FCtrlList[AIndex].Selected := True;
  end;
end;

//-----------------------------------------------------------------------------
//  \̑SĂ̕`Rg[폜
//-----------------------------------------------------------------------------
procedure TplContainerPanel.DeleteAllCtrls;
begin
  FCtrlList.Clear;
end;

//-----------------------------------------------------------------------------
//  \̑SĂ̕`Rg[I
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SelectAllCtrls;
var
  LCtrl   : TplBaseDragResize;
  LCtrlNo : Integer;
begin
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    LCtrl.Selected     := True;
    LCtrl.Mousethrough := True;
  end;
end;

//-----------------------------------------------------------------------------
//  SẴRg[̑I
//-----------------------------------------------------------------------------
procedure TplContainerPanel.DeSelectAllCtrls;
var
  LCtrl   : TplBaseDragResize;
  LCtrlNo : Integer;
begin
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    LCtrl.Selected     := False;
    LCtrl.Mousethrough := False;
  end;
end;

//-----------------------------------------------------------------------------
//  wCfbNX̕`Rg[őOʂɈړ
//  CfbNX̎w肪Ȃꍇ͑I𒆂̕`Rg[Ώ
//
//  Mousethrough͕̕`Rg[IԂ̌oɎgpĂ
//  MousethroughTrue̕`Rg[1łƕI
//-----------------------------------------------------------------------------
procedure TplContainerPanel.BringToFrontCtrl(AIndex: Integer);
var
  LCtrlNo : Integer;
  LCtrl   : TplBaseDragResize;
begin
  if AIndex >= 0 then begin
    if AIndex < FCtrlList.Count then begin
      LCtrl := FCtrlList[AIndex];
      LCtrl.BringToFront;
      FCtrlList.Move(AIndex, FCtrlList.Count -1);
    end;
  end else begin
    for LCtrlNo := FCtrlList.Count - 1 downto 0 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if (LCtrl.Selected) and (not LCtrl.Mousethrough) then begin
        LCtrl.BringToFront;
        FCtrlList.Move(LCtrlNo, FCtrlList.Count -1);
        break;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  wCfbNX̕`Rg[ŔwʂɈړ
//  CfbNX̎w肪Ȃꍇ͑I𒆂̕`Rg[Ώ
//
//  Mousethrough͕̕`Rg[IԂ̌oɎgpĂ
//  MousethroughTrue̕`Rg[1łƕI
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SendToBackCtrl(AIndex: Integer);
var
  LCtrlNo : Integer;
  LCtrl   : TplBaseDragResize;
begin
  if AIndex >= 0 then begin
    if AIndex < FCtrlList.Count then begin
      LCtrl := FCtrlList[AIndex];
      LCtrl.SendToBack;
      FCtrlList.Move(AIndex, 0);
    end;
  end else begin
    for LCtrlNo := FCtrlList.Count - 1 downto 0 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if (LCtrl.Selected) and (not LCtrl.Mousethrough) then begin
        LCtrl.SendToBack;
        FCtrlList.Move(LCtrlNo, 0);
        break;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  w`Rg[wZI[_ɂ
//  2̒lftHg-1͍̎őOʂɂ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SetZOrderCtrl(ACtrl: TplBaseDragResize;
  NewIndex: Integer);
var
  LOldIndex : Integer;
  LCtrlNo   : Integer;
begin
  if ACtrl = nil then exit;
  if (NewIndex < -1) or (NewIndex >= FCtrlList.Count) then exit;

  //̃CfbNX̕`Rg[̃CX^X擾
  LOldIndex := FCtrlList.IndexOf(ACtrl);
  if NewIndex = -1 then NewIndex := FCtrlList.Count - 1;
  if LOldIndex = NewIndex then exit;

  FCtrlList.Move(LOldIndex, NewIndex);
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    FCtrlList[LCtrlNo].BringToFront;
  end;
end;

//-----------------------------------------------------------------------------
//  wCfbNX̕`Rg[wZI[_ɂ
//  2̒lftHg-1͍̎őOʂɂ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SetZOrderCtrl(OldIndex, NewIndex: Integer);
var
  LCtrlNo : Integer;
begin
  if (OldIndex < 0)  or (OldIndex >= FCtrlList.Count) then exit;
  if (NewIndex < -1) or (NewIndex >= FCtrlList.Count) then exit;

  if NewIndex = -1 then NewIndex := FCtrlList.Count - 1;
  if OldIndex = NewIndex then exit;

  FCtrlList.Move(OldIndex, NewIndex);
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    FCtrlList[LCtrlNo].BringToFront;
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[̐
//  [C[CE[C[CE
//  alCustomw肷ƍE
//-----------------------------------------------------------------------------
procedure TplContainerPanel.AlignSelectedCtrls(AType: TAlign);
var
  LSelRect  : TRect;
  LSelWidth : Integer;
  LNo       : Integer;
  LCtrl     : TplBaseDragResize;
  LExtend   : Integer;
begin
  //I𒆂̃Rg[TRect̒l擾
  LSelRect := SelectedCtrlsRect;

  case AType of
  alLeft:
    begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LNo];
        if (LCtrl.Selected) and (LCtrl.Visible) then begin
          if LCtrl is TplGPResizeLine then begin
            LExtend    := LCtrl.Left - TplGPResizeLine(LCtrl).ExtendLeft;
            LCtrl.Left := LSelRect.Left + LExtend;
          end else begin
            LCtrl.Left := LSelRect.Left;
          end;
        end;
      end;
    end;
  alTop:
    begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LNo];
        if (LCtrl.Selected) and (LCtrl.Visible) then begin
          if LCtrl is TplGPResizeLine then begin
            LExtend   := LCtrl.Top - TplGPResizeLine(LCtrl).ExtendTop;
            LCtrl.Top := LSelRect.Left + LExtend;
          end else begin
            LCtrl.Top := LSelRect.Top;
          end;
        end;
      end;
    end;
  alRight:
    begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LNo];
        if (LCtrl.Selected) and (LCtrl.Visible) then begin
          if LCtrl is TplGPResizeLine then begin
            LExtend    := LSelRect.Right - TplGPResizeLine(LCtrl).ExtendRight;
            LCtrl.Left := LCtrl.Left + LExtend;
          end else begin
            LCtrl.Left := LSelRect.Right - LCtrl.Width;
          end;
        end;
        Application.ProcessMessages;
        Sleep(1);
      end;
    end;
  alBottom:
    begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LNo];
        if (LCtrl.Selected) and (LCtrl.Visible) then begin
          if LCtrl is TplGPResizeLine then begin
            LExtend   := LSelRect.Bottom - TplGPResizeLine(LCtrl).ExtendBottom;
            LCtrl.Top := LCtrl.Top + LExtend;
          end else begin
            LCtrl.Top := LSelRect.Bottom - LCtrl.Height;
          end;
        end;
      end;
    end;
  alCustom:
    begin
      LSelWidth := LSelRect.Right - LSelRect.Left;
      for LNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LNo];
        if (LCtrl.Selected) and (LCtrl.Visible) then begin
          if LCtrl is TplGPResizeLine then begin
            LExtend    := TplGPResizeLine(LCtrl).ExtendWidth;
            LCtrl.Left := LSelRect.Left + (LSelWidth - LExtend) div 2;
          end else begin
            LCtrl.Left := LSelRect.Left + (LSelWidth - LCtrl.Width) div 2;
          end;
        end;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[JXP[h񂷂郁\bh
//  `Rg[̊g͍̈lĂȂ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.CascadeSelectedCtrls(ADistance: Integer);
var
  LLeft  : Integer;
  LTop   : Integer;
  LNo    : Integer;
  LSelNo : Integer;
  LCtrl  : TplBaseDragResize;
begin
  LLeft  := 0;
  LTop   := 0;
  LSelNo := 1;

  for LNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LNo];
    if (LCtrl.Selected) and (LCtrl.Visible) then begin
      LCtrl.Left := LLeft + (LSelNo - 1) * ADistance;
      LCtrl.Top  := LTop  + (LSelNo - 1) * ADistance;
      inc(LSelNo);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[̕`1TGPBitmapɂ֐
//  \TCY(]Ԃ܂߂)̏ԂŎ擾
//
//  ĂяołTGPBimap𐶐ȂĂ悢
//  Ă悢Cݒe͔j
//  ʂTBitmap͌ďoŉCj
//-----------------------------------------------------------------------------
function TplContainerPanel.GPBitmapFromSelectedCtrls:
  TGPBitmap;
var
  LCtrl      : TplBaseDragResize;
  LSelRect   : TRect;
  LNo        : Integer;
  LGPBitmap  : TGPBitmap;
  LSelWidth  : Integer;
  LselHeight : Integer;
  LSelLeft   : Integer;
  LSelTop    : Integer;
  LCtrlLeft  : Integer;
  LCtrlTop   : Integer;
begin
  LSelRect   := SelectedCtrlsRect;
  LSelWidth  := LSelRect.Right  - LSelRect.Left;
  LselHeight := LSelRect.Bottom - LSelRect.Top;
  LSelLeft   := LSelRect.Left;
  LSelTop    := LSelRect.Top;

  LGPBitmap := TGPBitmap.Create(LSelWidth, LselHeight);
  try
    for LNo := 0 to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LNo];

      if LCtrl.Visible then begin
        if (LCtrl.Selected) or (LCtrl.DispOnly) then begin
          if LCtrl is TplGPResizeLine then begin
            LCtrlLeft := TplGPResizeLine(LCtrl).ExtendLeft;
            LCtrlTop  := TplGPResizeLine(LCtrl).ExtendTop;
          end else begin
            LCtrlLeft := LCtrl.Left;
            LCtrlTop  := LCtrl.Top;
          end;
          LCtrl.DrawRoutine(nil, LGPBitmap, LCtrlLeft - LSelLeft, LCtrlTop - LSelTop);
        end;
      end;
    end;

    Result := TGPBitmap(LGPBitmap.Clone);
  finally
    FreeAndNil(LGPBitmap);
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[̕`1TBitmapɂ郁\bh
//  \TCY(]Ԃ܂߂)̏ԂŎ擾
//
//  ĂяołTBimap𐶐Ă
//  CjďoōsDgp@TGPBitmap擾̊֐ƈႤ̂Œ
//-----------------------------------------------------------------------------
procedure TplContainerPanel.BitmapFromSelectedCtrls(ABitmap: TBitmap);
var
  LGPBitmap  : TGPBitmap;
  LImgGUID   : TGUID;
  LMemStream : TMemoryStream;
begin
  LMemStream := TMemoryStream.Create;
  LGPBitmap  := GPBitmapFromSelectedCtrls;
  try
    if GetEncoderClsid('image/bmp', LImgGUID) >= 0 then begin
      LGPBitmap.Save(TStreamAdapter.Create(LMemStream), LImgGUID);
      LMemStream.Position := 0;
      ABitmap.LoadFromStream(LMemStream);
    end;
  finally
    FreeAndNil(LGPBitmap);
    FreeAndNil(LMemStream);
  end;
end;

//-----------------------------------------------------------------------------
//  g܂͏k\\bh
//  A`GCAX̏Ȃŕ\
//  ̒l100̎͌̕\{
//  1000̎10{C50̎1/2̏k\
//
//  -1͐VKɕ`Rg[ǉꂽɎs
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SetZoomValue(AZoomValue: Integer);
var
  LCtrl    : TplBaseDragResize;
  LCtrlNo  : Integer;
  LStartNo : Integer;
  LTempInt : Integer;
begin
  if (AZoomValue > 1500) or ((AZoomValue < 20) and (AZoomValue <> -1)) then exit;


  if AZoomValue = 100 then begin
    if FZoomCurrensValue = FZoomOriginValue then exit;

    SetBounds(Left, Top, Width * 100 div FZoomValue, Height * 100 div FZoomValue);
    FZoomValue := 100;

    for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LCtrlNo];

      TContainerCtrl(LCtrl).ScaleBy(FZoomOriginValue, FZoomCurrensValue);
      TBaseResizeCtrl(LCtrl).ZoomValue := FZoomValue;

      LCtrl.Left := Trunc(LCtrl.Left * FZoomOriginValue / FZoomCurrensValue);
      LCtrl.Top  := Trunc(LCtrl.Top  * FZoomOriginValue / FZoomCurrensValue);
    end;
    FZoomBeforeValue  := FZoomOriginValue;
    FZoomCurrensValue := FZoomOriginValue;
  end else begin
    if AZoomValue = -1 then begin
      LStartNo := FCtrlList.Count - 1;
      if FZoomOriginValue = FZoomCurrensValue then exit;
      FZoomBeforeValue := FZoomOriginValue;
    end else begin
      LStartNo := 0;
      LTempInt := FZoomCurrensValue div  FZoomBeforeValue * FZoomOriginValue;
      FZoomCurrensValue := LTempInt * AZoomValue div 100;
      if FZoomCurrensValue = FZoomBeforeValue then exit;
    end;

    FZoomValue := Trunc(FZoomCurrensValue / FZoomOriginValue * 100);
    if AZoomValue <> -1 then begin
      SetBounds(Left, Top, Trunc(Width * FZoomCurrensValue / FZoomBeforeValue),
                           Trunc(Height * FZoomCurrensValue / FZoomBeforeValue));
    end;

    for LCtrlNo := LStartNo to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LCtrlNo];

      TContainerCtrl(LCtrl).ScaleBy(FZoomCurrensValue, FZoomBeforeValue);

      LCtrl.Left := Trunc(LCtrl.Left * FZoomCurrensValue / FZoomBeforeValue);
      LCtrl.Top  := Trunc(LCtrl.Top  * FZoomCurrensValue / FZoomBeforeValue);
      TBaseResizeCtrl(LCtrl).ZoomValue := FZoomValue;

      if LCtrl.Selected then begin
        LCtrl.Selected := False;
        LCtrl.Selected := True;
      end;
    end;
    FZoomBeforeValue := FZoomCurrensValue;
  end;
end;

//=============================================================================
//  WM_GETDLGCODEbZ[W
//  KeyDownœL[oɂ́CWM_GETDLGCODEbZ[W̏Kv
//  ̃Rg[etH[ActiveControlɂȂĂKv
//=============================================================================
procedure TplContainerPanel.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  inherited;
  //DLGC_WANTARROWSw肵āCL[v
  Message.Result := DLGC_WANTARROWS;
end;

//=============================================================================
//  KeyDown\bh
//  [Shift]L[ĂȂꍇ1hbgÂ̈ړ
//  [Shfit]L[ĂΉE[܂͉[ւ̃TCY
//=============================================================================
procedure TplContainerPanel.KeyDown(var Key: Word; Shift: TShiftState);
var
  LdecX      : Integer;
  LdecY      : Integer;
  LdecW      : Integer;
  LdecH      : Integer;
  LZoomValue : Integer;
  LRect      : TRect;
  LLeft      : Integer;
  LTop       : Integer;
  LWidth     : Integer;
  LHeight    : Integer;
begin
  inherited;
  if FCtrlList.Count <= 0 then exit;

  //[ESC]őI𑀍I
  if Key = VK_ESCAPE then begin
    FDragFlag   := False;
    if Assigned(FRubberShape) then FreeAndNil(FRubberShape);

    ClipCursor(nil);
    SetCaptureControl(nil);
    Screen.Cursor := crDefault;
    exit;
  end;
  if (Key < VK_LEFT) or (Key > VK_DOWN) then exit;

  LZoomValue := FZoomCurrensValue div 100;
  if LZoomValue < 0 then LZoomValue := 1;

  LdecX := 0;
  LdecY := 0;
  LdecW := 0;
  LdecH := 0;

  Screen.Cursor := crDefault;
  //[Shift\L[Ăꍇ̓TCY
  if (ssShift in Shift) then begin
    if Key = VK_LEFT  then LdecW := -LZoomValue;
    if Key = VK_RIGHT then LdecW := LZoomValue;
    if Key = VK_UP    then LdecH := -LZoomValue;
    if Key = VK_DOWN  then LdecH := LZoomValue;
  end else begin
    if Key = VK_LEFT  then LdecX := -LZoomValue;
    if Key = VK_RIGHT then LdecX := LZoomValue;
    if Key = VK_UP    then LdecY := -LZoomValue;
    if Key = VK_DOWN  then LdecY := LZoomValue;
  end;

  LRect := SelectedCtrlsRect;

  LLeft   := LRect.Left;
  LTop    := LRect.Top;
  LWidth  := Abs(LRect.Right  - LRect.Left);
  LHeight := Abs(LRect.Bottom - LRect.Top);

  MoveResizeControlByKey(LLeft, LTop, LWidth, LHeight, LdecX, LdecY, LdecW, LdecH);
end;

//-----------------------------------------------------------------------------
//  L[ɂړTCYp̃\bh
//
//  ̒lɂĕ`pRg[̈ʒuƃTCYݒ
//  TCY̓hbgP(䗦ł͂Ȃ)
//-----------------------------------------------------------------------------
procedure TplContainerPanel.MoveResizeControlByKey(ALeft, ATop,
   AWidth, AHeight, AdecX, AdecY, AdecW, AdecH: Integer);
var
  LCtrlNo    : Integer;
  LCtrl      : TplBaseDragResize;
  LADecX     : Integer;
  LADecY     : Integer;
  LADecW     : Integer;
  LADecH     : Integer;
  LLeft      : Integer;
  LTop       : Integer;
  LWidth     : Integer;
  LHeight    : Integer;
  LZoomValue : Integer;
  LLimit     : Integer;
begin
  LZoomValue := FZoomCurrensValue div 100;
  if LZoomValue < 0 then LZoomValue := 1;

  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];

    LADecX := AdecX;
    LADecY := AdecY;
    LADecW := AdecW;
    LADecH := AdecH;
    if LCtrl.DispOnly then begin
       LAdecX := 0;
       LAdecY := 0;
       LAdecW := 0;
       LAdecH := 0;
    end else
    if LCtrl.MoveOnly then begin
      LAdecW := 0;
      LAdecH := 0;
    end else
    if LCtrl.GrabHorzOnly then begin
      LAdecY := 0;
      LAdecH := 0;
    end else
    if LCtrl.GrabVertOnly then begin
      LAdecX := 0;
      LAdecW := 0;
    end;

    if LCtrl.Selected then begin
      if LAdecX < 0 then begin
        if (ALeft + AWidth - 10) < 0 then LAdecX := 0;
      end;
      if LAdecX > 0 then begin
        if ((ALeft + 30) > (Width)) then ScrollBy(-Abs(LAdecX), 0);
      end;
      LLeft := LCtrl.Left + LAdecX;

      if LAdecY < 0 then begin
        if (ATop + AHeight - 10) < 0 then LAdecY := 0;
      end;
      if LAdecY > 0 then begin
        if ((ATop + 30) > (Height)) then ScrollBy(0, -Abs(LAdecY));
      end;
      LTop  := LCtrl.Top  + LAdecY;

      LWidth  := LCtrl.Width  + LAdecW;
      LHeight := LCtrl.Height + LAdecH;

      //̒l菬lɂ͂łȂ悤ɂ
      LLimit := 1;
      if LWidth  <= (LLimit * LZoomValue) then LWidth  := (LLimit * LZoomValue);
      if LHeight <= (LLimit * LZoomValue) then LHeight := (LLimit * LZoomValue);

      LCtrl.SetBounds(LLeft, LTop, LWidth, LHeight);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[̑Ï̈ʒuƃTCYvZ
//-----------------------------------------------------------------------------
function TplContainerPanel.SelectedCtrlsRect: TRect;
var
  LCtrlNo    : Integer;
  LCtrl      : TplBaseDragResize;
  LLeft      : Integer;
  LTop       : Integer;
  LRight     : Integer;
  LBottom    : Integer;
  LExendRect : TRect;
begin
  LLeft   := MaxInt;
  LTop    := MaxInt;
  LRight  := 0;
  LBottom := 0;

  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    if (LCtrl.Selected) then begin
      if LCtrl is TplGPResizeLine then begin
        LExendRect := TplGPResizeLine(LCtrl).ExtendRect;
        //`NX͕ʈ(`̈悪gĂ)
        LLeft   := Min(LLeft,   LExendRect.Left);
        LTop    := Min(LTop,    LExendRect.Top);
        LRight  := Max(LRight,  LExendRect.Right);
        LBottom := Max(LBottom, LExendRect.Bottom);
      end else begin
        LLeft   := Min(LLeft,   LCtrl.Left);
        LTop    := Min(LTop,    LCtrl.Top);
        LRight  := Max(LRight,  LCtrl.Left + LCtrl.Width);
        LBottom := Max(LBottom, LCtrl.Top  + LCtrl.Height);
      end;
    end;
  end;
  Result := Rect(LLeft, LTop, LRight, LBottom);
end;

//-----------------------------------------------------------------------------
//  zuĂ`Rg[1ɂ̕ƍ擾
//  XN[Range̒lɑl
//-----------------------------------------------------------------------------
function TplContainerPanel.LocatedCtrlsRange: TPoint;
var
  LCtrlNo    : Integer;
  LCtrl      : TplBaseDragResize;
  LRight     : Integer;
  LBottom    : Integer;
  LExendRect : TRect;
begin
  LRight  := 0;
  LBottom := 0;

  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    if LCtrl is TplGPResizeLine then begin
      //`NX͕ʈ(`̈悪gĂ)
      LExendRect := TplGPResizeLine(LCtrl).ExtendRect;
      LRight  := Max(LRight,  LExendRect.Right);
      LBottom := Max(LBottom, LExendRect.Bottom);
    end else begin
      LRight  := Max(LRight,  LCtrl.Left + LCtrl.Width);
      LBottom := Max(LBottom, LCtrl.Top  + LCtrl.Height);
    end;
  end;
  Result := Point(LRight, LBottom);
end;

//-----------------------------------------------------------------------------
//  }EXJ[\Ɏw`Rg[݂邩𒲂ׂ֐
//-----------------------------------------------------------------------------
function TplContainerPanel.PtInResizeCtrl(X, Y: Integer;
  ACtrl: TplBaseDragResize): Boolean;
begin
  Result := (X >= ACtrl.Left) and (X <= (ACtrl.Left + ACtrl.Width));
  Result := Result and (Y >= ACtrl.Top) and (Y <= (ACtrl.Top + ACtrl.Height));;
end;

//-----------------------------------------------------------------------------
//  }EXJ[\̕`Rg[擾֐
//-----------------------------------------------------------------------------
function TplContainerPanel.GetPtInResizeCtrl(X, Y: Integer): TplBaseDragResize;
var
  LNo   : Integer;
  LCtrl : TplBaseDragResize;
begin
  Result := nil;
  if FCtrlList.Count = 0 then exit;

  for LNo := FCtrlList.Count -1 downto 0  do begin
    LCtrl := FCtrlList[LNo];
    if PtInResizeCtrl(x, Y, LCtrl) then begin
      Result := LCtrl;
      break;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  ExitMouseEventvpeB̐ݒp\bh
//  Trueɂ邱̃Rg[{̃}EXCxg͋@\ȂȂ
//  `Rg[̃}EXCxgȂȂ
//  {Rg[pNXœƎ̃}EXR[ĥɗp\
//-----------------------------------------------------------------------------
procedure TplContainerPanel.SetFExitMouseEvent(const Value: Boolean);
var
  LNo : Integer;
begin
  if FExitMouseEvent <> Value then begin
    FExitMouseEvent := Value;

    if FExitMouseEvent then begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        FCtrlList[LNo].Mousethrough := True;
        TBaseResizeCtrl(FCtrlList[LNo]).ExitMouseEvent := True;
      end;
    end else begin
      for LNo := 0 to FCtrlList.Count - 1 do begin
        FCtrlList[LNo].Mousethrough := False;
        TBaseResizeCtrl(FCtrlList[LNo]).ExitMouseEvent := False;
      end;
    end;
  end;
end;

//=============================================================================
//  MouseDown\bh
//
//  ȉ̂ꂩ̑
//  (1) ̃Rg[̑I
//      [Ctrl]L[ԂŃ}EXŃo[̓oh`đI
//  (2) I𒆂̕̕`Rg[̈ړ
//  (3) Ỉ
//      `Rg[ȊÔƂŃ}EX̍{^
//
//  SelectModevpeBTrueɂFalseɂ܂ŕI[hƂȂ
//  [Ctrl]+[}EX{^]ŕ̕`Rg[Ił
//  ̋@\͕`p̈ړTCY̊{NXɎĂ
//=============================================================================
procedure TplContainerPanel.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  LCtrl        : TplBaseDragResize;
  LCtrlNo      : Integer;
  LMultiSelect : Boolean;
  LClipRect    : TRect;
  LForm        : TCustomForm;
begin
  inherited;

  //L[ɂ鑀\ɂ
  //etH[ô̕@͊ȕ֖@
  LForm := GetParentForm(Self);
  if LForm <> nil then begin
    LForm.ActiveControl := Self;
  end;
  if FExitMouseEvent then exit;
  if Button <> mbLeft then exit;


  LMultiSelect := False;
  for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
    LCtrl := FCtrlList[LCtrlNo];
    //1ł}EXCxgߏԂłΕ̑IԂƂ݂Ȃ
    if  LCtrl.Mousethrough = True then begin
      LMultiSelect := True;
      Break;
    end;
  end;

  FPtInAnyCtrlRect := False;
  if LMultiSelect then begin
    for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if PtInResizeCtrl(X, Y, LCtrl) then begin
        if LCtrl.Selected then begin
          FPtInAnyCtrlRect := True;
        end else begin
          FPtInAnyCtrlRect := True;
          DeSelectAllCtrls;
          LCtrl.Selected     := True;
          LCtrl.Mousethrough := False;
        end;
        Break;
      end;
    end;
  end;

  if not FPtInAnyCtrlRect then begin
    if (ssCtrl in Shift) or FSelectMode then begin
      GetWindowRect(Handle, LClipRect);
      ClipCursor(@LClipRect);

      FDragFlag   := True;
      FDragStartX := X;
      FDragStartY := Y;
    end else begin
      DeSelectAllCtrls;
    end;
  end else begin
    //ړJn
    GetWindowRect(Handle, LClipRect);
    ClipCursor(@LClipRect);
    Screen.Cursor := crSizeAll;

    FDragFlag   := True;
    FDragStartX := X;
    FDragStartY := Y;
  end;
end;

//=============================================================================
//  MouseMove\bh
//=============================================================================
procedure TplContainerPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  LCtrl    : TplBaseDragResize;
  LCtrlNo  : Integer;
  LIncX    : Integer;
  LIncY    : Integer;
  LLeft    : Integer;
  LTop     : Integer;
  LWidth   : Integer;
  LHeight  : Integer;
  LSumRect : TRect;
begin
  inherited;
  if FExitMouseEvent then exit;
  if not FDragFlag then exit;

  //o[oh̕`
  if not FPtInAnyCtrlRect then begin
    if (X <> FDragStartX) or (Y <> FDragStartY) then begin
      if not Assigned(FRubberShape) then begin
        FRubberShape := TShape.Create(Self);
        FRubberShape.Parent      := Self;
        FRubberShape.Brush.Style := bsClear;
        FRubberShape.Pen.Width   := 2;
        FRubberShape.Pen.Style   := psDot;
      end;

      LLeft   := FDragStartX;
      LTop    := FDragStartY;
      LWidth  := X - FDragStartX;
      LHeight := Y - FDragStartY;

      if LWidth < 0 then begin
        LLeft := FDragStartX - Abs(LWidth);
      end;
      if LHeight < 0 then begin
        LTop := FDragStartY - Abs(LHeight);
      end;
      FRubberShape.SetBounds(LLeft,  LTop, Abs(LWidth), Abs(LHeight));
    end;
  end else begin
    //̃Rg[̈ړ
    LIncX := X - FDragStartX;
    LIncY := Y - FDragStartY;

    LSumRect := SelectedCtrlsRect;

    //I𒆂̃Rg[ړ
    for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if LCtrl.Selected then begin
        LLeft := LCtrl.Left + LIncX;
        LTop  := LCtrl.Top  + LIncY;
        LCtrl.SetBounds(LLeft, LTop, LCtrl.Width, LCtrl.Height);
      end;
    end;
    FDragStartX := X;
    FDragStartY := Y;
  end;
end;

//=============================================================================
//  MouseUp\bh
//=============================================================================
procedure TplContainerPanel.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  LLeft       : Integer;
  LTop        : Integer;
  LWidth      : Integer;
  LHeight     : Integer;
  LSelectRect : TRect;
  LRect       : TRect;
  LOutRect    : TRect;
  LCtrl       : TplBaseDragResize;
  LCtrlNo     : Integer;
  LSetCnt     : Integer;
  LZoomValue  : Integer;
  LForm       : TCustomForm;
begin
  inherited;

  //etH[ô̕@͊ȕ֖@
  LForm := GetParentForm(Self);
  if LForm <> nil then begin
    LForm.ActiveControl := Self;
  end;
  if FExitMouseEvent then exit;
  if not FDragFlag then exit;


  LZoomValue := FZoomCurrensValue div FZoomOriginValue;
  if LZoomValue < 0 then LZoomValue := 1;

  FDragFlag := False;

  //o[oh쒆
  //FPtInAnyCtrlRect(MouseDowñ}EẌʒu`Rg[)
  if not FPtInAnyCtrlRect then begin
    if Assigned(FRubberShape) then begin
      //o[oh(TShape)̕`I
      LLeft   := FRubberShape.Left;
      LTop    := FRubberShape.Top;
      LWidth  := FRubberShape.Width;
      LHeight := FRubberShape.Height;

      LSelectRect := Rect(LLeft, LTop,  LLeft + LWidth, LTop + LHeight);

      //Rg[̋`̈̈ꕔTShape̋`ɂΑI
      LSetCnt := 0;
      for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
        LCtrl := FCtrlList[LCtrlNo];
        LRect := Rect(LCtrl.Left,
                      LCtrl.Top,
                      LCtrl.Left + LCtrl.Width,
                      LCtrl.Top  + LCtrl.Height);

        if IntersectRect(LOutRect, LSelectRect, LRect) then begin
          inc(LSetCnt);
          LCtrl.Selected := True;
        end else begin
          LCtrl.Selected     := False;
          LCtrl.Mousethrough := False;
        end;
      end;
      //I`Rg[2ȏ̎͂̃}EX߂Trueɂ
      //}EX߂Ƃ̔wiRg[}EXCxg󂯎
      if LSetCnt >= 2 then begin
        for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
          LCtrl := FCtrlList[LCtrlNo];
          if LCtrl.Selected then begin
            LCtrl.Mousethrough := True;
          end;
        end;
      end;
    end;
    if Assigned(FRubberShape) then FreeAndNil(FRubberShape);
    ClipCursor(nil);
    SetCaptureControl(nil);
    Screen.Cursor := crDefault;
  end else begin
    //̃Rg[̈ړI
    for LCtrlNo := 0 to FCtrlList.Count - 1 do begin
      LCtrl := FCtrlList[LCtrlNo];
      if LCtrl.Selected then begin
        LLeft := LCtrl.Left div LZoomValue * LZoomValue;
        LTop  := LCtrl.Top  div LZoomValue * LZoomValue;
        LCtrl.SetBounds(LLeft, LTop, LCtrl.Width, LCtrl.Height);
      end;
    end;

    ClipCursor(nil);
    SetCaptureControl(nil);
    Screen.Cursor := crDefault;
  end;
end;

{ TplCtrlList }

//=============================================================================
//  Clear\bh
//  overrideł͂ȂƎ
//=============================================================================
procedure TplCtrlList.Clear;
begin
  FSelfBackControl.SetZoomValue();
  Count := 0;
  Capacity := 0;
end;

//=============================================================================
//  TList<T>Item̒ǉ폜̎ɔʒmbZ[W
//=============================================================================
procedure TplCtrlList.Notify(const Item: TplBaseDragResize;
  Action: TCollectionNotification);
var
  LCtrl   : TplBaseDragResize;
  LCtrlNo : Integer;
  LFlag   : Boolean;
begin
  inherited;

  LFlag := True;
  if Action = cnAdded then begin
    //OAddĂ܂ꍇ̏u
    for LCtrlNo := Count - 2 downto 0 do begin
      LCtrl := Items[LCtrlNo];
      if LCtrl = Item then begin
        Extract(Item);
        LFlag := False;
        Break;
      end;
    end;
    //ǉ`Rg[IԂɂ
    if LFlag then begin
      for LCtrlNo := 0 to Count - 2 do begin
        LCtrl := Items[LCtrlNo];
        LCtrl.Selected := False;
      end;
      Item.Selected := True;
    end;
  end else
  if Action = cnRemoved then begin
    if Item <> nil then begin
      LCtrl := Item;
      FreeAndNil(LCtrl);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  I𒆂̕`Rg[̐Ԃ֐
//-----------------------------------------------------------------------------
function TplCtrlList.SelCount: Integer;
var
  LCtrlNo : Integer;
  LSelCnt : Integer;
begin
  LSelCnt := 0;
  for LCtrlNo := 0 to Count - 1 do begin
    if Items[LCtrlNo].Selected then  Inc(LSelCnt);
  end;
  Result := LSelCnt;
end;

//-----------------------------------------------------------------------------
//  ItemIndexvpeB̐ݒp\bh
//  I`Rg[w肷
//  ̃vpeBŐݒ肷Ƒ̑SĂ̑I͉
//-----------------------------------------------------------------------------
procedure TplCtrlList.SetFItemIndex(const Value: Integer);
var
  LCtrlNo : Integer;
begin
  if (Value >= 0) and (Value < Count) then begin
    for LCtrlNo := 0 to Count - 1 do begin
      if Value = LCtrlNo then begin
        Items[LCtrlNo].Selected:= True;
      end else begin
        Items[LCtrlNo].Selected:= False;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  ItemIndexvpeB̎擾p\bh
//  IĂȂ-1Ԃ
//  IZI[_̈ԒႢ`Rg[̃CfbNXԂ
//-----------------------------------------------------------------------------
function TplCtrlList.GetFItemIndex: Integer;
var
  LCtrlNo : Integer;
begin
  Result := -1;
  for LCtrlNo := 0 to Count - 1 do begin
    if Items[LCtrlNo].Selected then  begin
      Result := LCtrlNo;
      Break;
    end;
  end;
end;

end.
