﻿//=============================================================================
//  移動リサイズコントロール関係サンプル
//  楕円描画用のクラス 　VCL のみ。しない
//
//=============================================================================
unit plResizeEllipse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, plBaseDragResize,
  GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TplResizeEllipse = class(TplBaseDragResize)
  private
    FPenColor   : TColor;
    FPenWidth   : Integer;
    FBrushColor : TColor;
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DrawRoutine(ACanvas: TCanvas; AGPBitmap: TGPBitmap = nil;
      AOffsetX: Integer = 0; AOffsetY: Integer = 0); override;
  end;

implementation

uses
  Types,
  Math;

{ TplResizeEllipse }

//=============================================================================
//  コンストラクタ
//=============================================================================
constructor TplResizeEllipse.Create(AOwner: TComponent);
begin
  inherited;

  FBrushColor := $000000;
  FPenColor := clBlue;
  FPenWidth := 8;
end;

//=============================================================================
//  デコンストラクタ処理
//=============================================================================
destructor TplResizeEllipse.Destroy;
begin
//
  inherited;
end;

//-----------------------------------------------------------------------------
//  実際の描画処理を実行するDrawRoutineメソッド
//  引数のACanvasにこのメソッドの描画コードを実行する
//
//  描画開始位置は(DrawLeft, DrawTop)
//  幅と高さは DrawWidth, DrawHeight
//-----------------------------------------------------------------------------
procedure TplResizeEllipse.DrawRoutine(ACanvas: TCanvas; AGPBitmap: TGPBitmap;
  AOffsetX: Integer; AOffsetY: Integer);
var
  LHalfW : Integer;
  LHalfH : Integer;
begin
  inherited;
  SetBounds(Left, Top, Width, Height);

  ACanvas.Pen.Width := FPenWidth;
  ACanvas.Pen.Color := FPenColor;
  ACanvas.Brush.Style := bsClear;

  LHalfW := Sign(DrawWidth) * FPenWidth div 2;
  LHalfH := Sign(DrawHeight) * FPenWidth div 2;
  Acanvas.Ellipse(DrawLeft + LHalfw, DrawTop + LHalfH,
                  DrawLeft + DrawWidth - LHalfW, DrawTop + DrawHeight - LHalfH);
end;

end.
